org.apache.xpath.axes

## Class FilterExprIteratorSimple

- java.lang.Object
- - org.apache.xpath.Expression
  - - org.apache.xpath.patterns.NodeTest
    - - org.apache.xpath.axes.PredicatedNodeTest
      - - org.apache.xpath.axes.LocPathIterator
        - - org.apache.xpath.axes.FilterExprIteratorSimple

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, SourceLocator, DTMIterator, PathComponent, SubContextList, ExpressionNode, XPathVisitable

    public class FilterExprIteratorSimple
    extends LocPathIterator

Class to use for one-step iteration that doesn't have a predicate, and doesn't need to set the context.

See Also:
  Serialized Form

### Field Summary

### Fields inherited from class org.apache.xpath.axes.LocPathIterator

`m_lastFetched`

### Fields inherited from class org.apache.xpath.patterns.NodeTest

`SCORE_NODETEST, SCORE_NONE, SCORE_NSWILD, SCORE_OTHER, SCORE_QNAME, SHOW_BYFUNCTION, SUPPORTS_PRE_STRIPPING, WILD`

### Fields inherited from interface org.apache.xml.dtm.DTMIterator

`FILTER_ACCEPT, FILTER_REJECT, FILTER_SKIP`

### Constructor Summary

Constructors
Constructor and Description
`FilterExprIteratorSimple()` Create a FilterExprIteratorSimple object.
`FilterExprIteratorSimple(Expression expr)` Create a FilterExprIteratorSimple object.

### Method Summary

Methods
`void` `callPredicateVisitors(XPathVisitor visitor)` This will traverse the heararchy, calling the visitor for each member.
`boolean` `deepEquals(Expression expr)` Compare this object with another object and see if they are equal, include the sub heararchy.
`void` `detach()` Detaches the walker from the set which it iterated over, releasing any computational resources and placing the iterator in the INVALID state.
`static XNodeSet` `executeFilterExpr(int context, XPathContext xctxt, PrefixResolver prefixResolver, boolean isTopLevel, int stackFrame, Expression expr)` Execute the expression.
`void` `fixupVariables(java.util.Vector vars, int globalsSize)` This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.
`int` `getAnalysisBits()` Get the analysis bits for this walker, as defined in the WalkerFactory.
`int` `getAxis()` Returns the axis being iterated, if it is known.
`Expression` `getInnerExpression()` Get the inner contained expression of this filter.
`boolean` `isDocOrdered()` Returns true if all the nodes in the iteration well be returned in document order.
`int` `nextNode()` Returns the next node in the set and advances the position of the iterator in the set.
`void` `setInnerExpression(Expression expr)` Set the inner contained expression of this filter.
`void` `setRoot(int context, java.lang.Object environment)` Initialize the context values for this expression after it is cloned.

### Methods inherited from class org.apache.xpath.axes.LocPathIterator

`allowDetachToRelease, asIterator, asNode, bool, callVisitors, cloneWithReset, execute, executeCharsToContentHandler, getContext, getCurrentContextNode, getCurrentNode, getCurrentPos, getDTM, getDTMManager, getExpandEntityReferences, getFilter, getFoundLast, getIsTopLevel, getLastPos, getLength, getPrefixResolver, getRoot, getWhatToShow, getXPathContext, incrementCurrentPos, isFresh, isMutable, isNodesetExpr, item, previousNode, reset, runTo, setCurrentContextNode, setCurrentPos, setEnvironment, setIsTopLevel, setItem, setShouldCacheNodes, size`

### Methods inherited from class org.apache.xpath.axes.PredicatedNodeTest

`acceptNode, canTraverseOutsideSubtree, clone, getLocPathIterator, getPredicate, getPredicateCount, getPredicateIndex, getProximityPosition, getProximityPosition, initProximityPosition, isReverseAxes, resetProximityPositions, setLocPathIterator, setPredicateCount`

### Methods inherited from class org.apache.xpath.patterns.NodeTest

`debugWhatToShow, execute, execute, getDefaultScore, getLocalName, getNamespace, getNodeTypeTest, getStaticScore, initNodeTest, initNodeTest, setLocalName, setNamespace, setStaticScore, setWhatToShow`

### Methods inherited from class org.apache.xpath.Expression

`asIteratorRaw, assertion, error, execute, exprAddChild, exprGetChild, exprGetNumChildren, exprGetParent, exprSetParent, getColumnNumber, getExpressionOwner, getLineNumber, getPublicId, getSystemId, isStableNumber, num, warn, xstr`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.xml.dtm.DTMIterator

`clone`

### Constructor Detail

#### FilterExprIteratorSimple

    public FilterExprIteratorSimple()

Create a FilterExprIteratorSimple object.

#### FilterExprIteratorSimple

    public FilterExprIteratorSimple(Expression expr)

Create a FilterExprIteratorSimple object.

### Method Detail

#### setRoot

    public void setRoot(int context,
               java.lang.Object environment)

Initialize the context values for this expression after it is cloned.

Specified by:
  `setRoot` in interface `DTMIterator`
Overrides:
  `setRoot` in class `LocPathIterator`
Parameters:
  `context` - The XPath runtime context for this transformation.
  `environment` - The environment object. The environment in which this iterator operates, which should provide:
  - a node (the context node... same value as "root" defined below)
  - a pair of non-zero positive integers (the context position and the context size)
  - a set of variable bindings
  - a function library
  - the set of namespace declarations in scope for the expression.

  At this time the exact implementation of this environment is application dependent. Probably a proper interface will be created fairly soon.

#### executeFilterExpr

    public static XNodeSet executeFilterExpr(int context,
                             XPathContext xctxt,
                             PrefixResolver prefixResolver,
                             boolean isTopLevel,
                             int stackFrame,
                             Expression expr)
                                      throws WrappedRuntimeException

Execute the expression. Meant for reuse by other FilterExpr iterators that are not derived from this object.

Throws:
  `WrappedRuntimeException`

#### nextNode

    public int nextNode()

Returns the next node in the set and advances the position of the iterator in the set. After a NodeIterator is created, the first call to nextNode() returns the first node in the set.

Specified by:
  `nextNode` in interface `DTMIterator`
Specified by:
  `nextNode` in class `LocPathIterator`
Returns:
  The next `Node` in the set being iterated over, or `null` if there are no more members in that set.

#### detach

    public void detach()

Detaches the walker from the set which it iterated over, releasing any computational resources and placing the iterator in the INVALID state.

Specified by:
  `detach` in interface `DTMIterator`
Overrides:
  `detach` in class `LocPathIterator`

#### fixupVariables

    public void fixupVariables(java.util.Vector vars,
                      int globalsSize)

This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.

Overrides:
  `fixupVariables` in class `PredicatedNodeTest`
Parameters:
  `vars` - List of QNames that correspond to variables. This list should be searched backwards for the first qualified name that corresponds to the variable reference qname. The position of the QName in the vector from the start of the vector will be its position in the stack frame (but variables above the globalsTop value will need to be offset to the current stack frame).

#### getInnerExpression

    public Expression getInnerExpression()

Get the inner contained expression of this filter.

#### setInnerExpression

    public void setInnerExpression(Expression expr)

Set the inner contained expression of this filter.

#### getAnalysisBits

    public int getAnalysisBits()

Get the analysis bits for this walker, as defined in the WalkerFactory.

Specified by:
  `getAnalysisBits` in interface `PathComponent`
Overrides:
  `getAnalysisBits` in class `LocPathIterator`
Returns:
  One of WalkerFactory#BIT_DESCENDANT, etc.

#### isDocOrdered

    public boolean isDocOrdered()

Returns true if all the nodes in the iteration well be returned in document order. Warning: This can only be called after setRoot has been called!

Specified by:
  `isDocOrdered` in interface `DTMIterator`
Overrides:
  `isDocOrdered` in class `LocPathIterator`
Returns:
  true as a default.

#### callPredicateVisitors

    public void callPredicateVisitors(XPathVisitor visitor)

This will traverse the heararchy, calling the visitor for each member. If the called visitor method returns false, the subtree should not be called.

Overrides:
  `callPredicateVisitors` in class `PredicatedNodeTest`
Parameters:
  `visitor` - The visitor whose appropriate method will be called.

#### deepEquals

    public boolean deepEquals(Expression expr)

Description copied from class: `Expression`
Compare this object with another object and see if they are equal, include the sub heararchy.

Overrides:
  `deepEquals` in class `PredicatedNodeTest`
Parameters:
  `expr` - Another expression object.
Returns:
  true if this objects class and the expr object's class are the same, and the data contained within both objects are considered equal.
See Also:
  `Expression.deepEquals(Expression)`

#### getAxis

    public int getAxis()

Returns the axis being iterated, if it is known.

Specified by:
  `getAxis` in interface `DTMIterator`
Overrides:
  `getAxis` in class `LocPathIterator`
Returns:
  Axis.CHILD, etc., or -1 if the axis is not known or is of multiple types.